CreateClient:
  handler: src/client/handler/create-client.handler
  name: ${file(resource/index.json):client.createClientFunction}
  environment:
    CLIENT_TABLE: !Ref ClientsDynamoDbTable
    CLIENT_CREATED_TOPIC: !Ref ClientCreatedTopic
  iamRoleStatementsInherit: true
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:PutItem
      Resource:
        - !GetAtt ClientsDynamoDbTable.Arn
    - Effect: Allow
      Action:
        - sns:Publish
      Resource:
        - !Ref ClientCreatedTopic
  events:
    - http:
        path: client
        method: post
        cors: true

GetAllClients:
  handler: src/client/handler/get-all-clients.handler
  name: ${file(resource/index.json):client.getAllClientsFunction}
  environment:
    CLIENT_TABLE: !Ref ClientsDynamoDbTable
  iamRoleStatementsInherit: true
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:Scan
      Resource:
        - !GetAtt ClientsDynamoDbTable.Arn
  events:
    - http:
        path: client
        method: get
        cors: true

GetClientById:
  handler: src/client/handler/get-client.handler
  name: ${file(resource/index.json):client.getClientByIdFunction}
  environment:
    CLIENT_TABLE: !Ref ClientsDynamoDbTable
  iamRoleStatementsInherit: true
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:GetItem
      Resource:
        - !GetAtt ClientsDynamoDbTable.Arn
  events:
    - http:
        path: client/{id}
        method: get
        cors: true

DeleteClient:
  handler: src/client/handler/delete-client.handler
  name: ${file(resource/index.json):client.deleteClientFunction}
  environment:
    CLIENT_TABLE: !Ref ClientsDynamoDbTable
  iamRoleStatementsInherit: true
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:UpdateItem
      Resource:
        - !GetAtt ClientsDynamoDbTable.Arn
  events:
    - http:
        path: client/{id}
        method: delete
        cors: true

UpdateClient:
  handler: src/client/handler/update-client.handler
  name: ${file(resource/index.json):client.updateClientFunction}
  environment:
    CLIENT_TABLE: !Ref ClientsDynamoDbTable
    CLIENT_UPDATED_TOPIC: !Ref ClientUpdatedTopic
  iamRoleStatementsInherit: true
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:UpdateItem
        - dynamodb:GetItem
      Resource:
        - !GetAtt ClientsDynamoDbTable.Arn
    - Effect: Allow
      Action:
        - sns:Publish
      Resource:
        - !Ref ClientUpdatedTopic
  events:
    - http:
        path: client/{id}
        method: put
        cors: true
